program COMMTest;

uses COMMUnit, Crt;

var
  {Stores an incoming byte}
  Incoming : Byte;
  C, I : Byte;
  {Stores the user's keypress}
  Key : Char;

function Binary (a : Byte) : String;
var
  s : String;
  t : Byte;

begin
  s := '';
  for t := 1 to 8 do begin
    if a and 1 = 1 then s := '1' + s else s := '0' + s;
    a := a shr 1;
  end;
  Binary := s;
end;

begin
  {Clear the screen}
  ClrScr;

  Write ('COM poort:'); Readln (C);
  Write ('IRQ niveau:'); Readln (I);

  {Open COM 2 with IRQ 3 at a speed of 28800 baud - change
  this to match your settings}
  COMOpenPort (C, I, 14400);

  repeat
    {If new data is available, display it on-screen}
    if COMReadByte (Incoming) then begin
      Write (Chr (Incoming));
      Writeln (' '+Binary (Incoming));
    end;
    {If a key has been pressed, handle it...}
    if KeyPressed then begin
      {Retrieve the code}
      Key := ReadKey;
      {Display on-screen}
      Write (Key);
      Writeln (' '+Binary (Ord(Key)));
      {Write to the COM port}
      COMWriteByte (Ord (Key));
      {If it was ENTER (actually, carriage return), we need to add Line Feed}
      if Key = #13 then begin
        Write (#10);
        COMWriteByte (10);
      end;
    end;
    {Continue until ESC was pressed}
  until Key = #27;

  {Close the COM port}
  COMClosePort;
end.